//Proyecto de Iniciación a la programación paralela en los módulos de informática
//Universidad de Murcia - Instituto de Enseñanza Secundaria Ingeniero de la Cerva, Murcia
//2014

//Ejemplo de uso de pipe entre dos procesos, en C
//suma de números usando dos procesos que se comunican por una pipe

//En linux, 
//compilar con: gcc pipe-basico.c
//incluir la opción -O3 para optimizar el código
//ejecutar con: ./a.out

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>

void generararray(int *a,int n)
{
	int i;

	for(i=0;i<n;i++)
		a[i]=i;
}

void escribirarray(int *a,int n,pid_t id)
{
	int i;

	printf("En proceso %d, datos:\n");
	for(i=0;i<n;i++)
		printf("%d ",a[i]);
	printf("\n");
}

int sumar(int *a,int n)
{
	int i,suma=0;

	for(i=0;i<n;i++)
		suma+=a[i];
	return suma;
}

int main(void)
{
        int  pipedesc[2]; //contendrá los descriptores de la pipe
	int suma; //guarda las sumas locales
	int temp; //recibe en el padre la suma que ha realizado el hijo
        pid_t  pid; //identificador de proceso
        int datos[10]; //contiene los datos
	int datosl[5]; //se almacenarán los datos que recibe el hijo

        pipe(fd);

	pid=fork();

        if(pid == 0)
        {
 //el hijo recibe (por pipedesc[0]) 5 datos, los suma y devuelve (por pipedesc[1]) la suma al padre
		read(pipedesc[0], &datosl[0], sizeof(int)*5);
		escribirarray(datosl,5,pid);
                suma=sumar(datosl,5);
                printf("Suma en hijo %d\n",suma);
		write(pipedesc[1],&suma,sizeof(int));
                exit(0);
        }
        else
        {
//el padre genera los 10 datos, manda los 5 últimos al hijo, suma los 5 primeros, recibe la suma parcial del hijo y obtiene la suma total
		generararray(datos,10);
		escribirarray(datos,10,pid);
                write(pipedesc[1],&datos[5],sizeof(int)*5);
		suma=sumar(datos,5);
		printf("Suma en padre %d\n",suma);
		read(pipedesc[0],&temp,sizeof(int));
		suma+=temp;
                printf("Suma total %d\n", suma);
        }
        
        return(0);
}
