//Proyecto de Iniciación a la programación paralela en los módulos de informática
//Universidad de Murcia - Instituto de Enseñanza Secundaria Ingeniero de la Cerva, Murcia
//2014

//Ejemplo básico de captura de flujo de entrada de un proceso esclavo, en Java
//este es el proceso maestro, que pone en marcha otro proceso esclavo

//En linux, 
//compilar el maestro y el esclavo, con: 
//javac esclavo.java
//javac maestro.java
//ejecutar el maestro con: java maestro N
//con N un número que se pasa al esclavo al ponerlo en marcha,
//y este lo pasa al maestro a través del flujo de entrada

import java.io.*;

public class maestro
{

   public static void main(String args[])
   {
      Process esclavo=null;
      BufferedReader inStream = null;
      String s=null;

      System.out.println("Salida desde el proceso principal\n");
      
     try
     {  
//se pone en marcha el proceso esclavo mandándole el argumento que se pasa al maestro
          esclavo = Runtime.getRuntime().exec("java esclavo "+args[0]);
      }
      catch(IOException e)
      {
         System.err.println("Error en el método exec()");
         e.printStackTrace();
      }
 
       try
      {
//se toma como flujo de entrada a través de un buffer de lectura el flujo del esclavo
        inStream = new BufferedReader(new InputStreamReader( esclavo.getInputStream() ));
 
        s=inStream.readLine();
        System.out.format("Cadena recibida del esclavo: %s\n",s);
      }
      catch(IOException e)
      {
         System.err.println("Error en inStream.readLine()");
         e.printStackTrace();
      }
   } // Fin del método.
 
} // Fin de la clase.


