//Proyecto de Iniciación a la programación paralela en los módulos de informática
//Universidad de Murcia - Instituto de Enseñanza Secundaria Ingeniero de la Cerva, Murcia
//2014

//Ejemplo básico de captura de flujo de entrada de un proceso esclavo, en Java
//este es el proceso maestro, que pone en marcha otro proceso esclavo

//En linux, 
//compilar el maestro y el esclavo, con: 
//javac esclavo.java
//javac maestro.java
//ejecutar el maestro con: java maestro N
//con N un número que se pasa al esclavo al ponerlo en marcha,
//y este lo pasa al maestro a través del flujo de entrada

import java.io.*;
import java.util.StringTokenizer;
import java.util.Formatter.*;

public class maestroOrdenar
{

   public static void escribir(int x[],int t)
   {
       int i;

       for(i=0;i<t;i++)
       {  
            System.out.format("%d ",x[i]); 
       }
      System.out.format("\n"); 
   }

   public static void ordenar(int x[],int izq,int der)
  {
      int i,j;
      int temp;

      for(i=izq;i<der;i++)
      {
          for(j=i+1;j<der;j++)
          {
               if(x[i]>x[j])
               {
                   temp=x[i];
                   x[i]=x[j];
                   x[j]=temp;
               }
           }
       }
    }

    private static void mezclar(int x[],int t)
   {
        int i,j,k;
        int[] temp=new int[t];

        i=0;
        j=t/2;
        k=0;
        while(i<t/2 && j<t)
        {
            if(x[i]<x[j])
           {
               temp[k]=x[i];
               i++;
           }
          else
          {
               temp[k]=x[j];
               j++;
          }
          k++;
      }
     for(;i<t/2;i++)
    {
         temp[k]=x[i];
         k++;
    }
    for(;j<t;j++)
    {
        temp[k]=x[j];
        k++;
    }
    for(i=0;i<t;i++)
    {
        x[i]=temp[i];
    }
 }
    
    private static int comparar(int x[],int y[],int t)
   {
       int i;
       int total=0;

       for(i=0;i<t;i++)
      {
           total=(y[i]>x[i]?y[i]-x[i]:x[i]-y[i]);
      }
      return total;
   }

   private static void convertir(String s,int t,int x[],int izq,int der)
   {
	String[] datosstring;
        int i,j;

   	s=s.replace("[","");
        s=s.replace("]","");
	s=s.replace(",","");
//Quitar el conmentario si se quiere seguir la ejecución
//	System.out.format("datos ordenados: %s\n",s);
	datosstring=s.split(" ");
	for(i=izq,j=0;i<der;i++,j++)
        {
		x[i]= Integer.valueOf(datosstring[j]);
//Quitar el conmentario si se quiere seguir la ejecución
//		System.out.format("String %s pasado a int: %d\n",datosstring[j],x[i]);
 	}
    }

   public static void main(String args[])
   {
      Process esclavo=null;
      BufferedReader inStream = null;
      String s=null;
      int n=Integer.parseInt(args[0]);
      int j,i;
      long ti,tf;
      int[] datos=new int[n];
      int[] copiadatos=new int[n];
      String[] datosstring;

     try
     {  
//se pone en marcha el proceso esclavo mandándole el argumento que se pasa al maestro
          esclavo = Runtime.getRuntime().exec("java esclavoOrdenar "+args[0]);
      }
      catch(IOException e)
      {
         System.err.println("Error en el método exec()");
         e.printStackTrace();
      }
 
       try
      {
//se toma como flujo de entrada a través de un buffer de lectura el flujo del esclavo
        inStream = new BufferedReader(new InputStreamReader( esclavo.getInputStream() ));
 
        s=inStream.readLine();
        System.out.format("%s\n",s);
 	s=inStream.readLine();
//Quitar el conmentario si se quiere seguir la ejecución
//     System.out.format("datos ordenados: %s\n",s);
	convertir(s,n,copiadatos,0,n);
	s=inStream.readLine();
        ti=Long.parseLong(s);
//Quitar el conmentario si se quiere seguir la ejecución
//        System.out.format("Tiempo inicial: %d\n",ti);
 	s=inStream.readLine();
//Quitar el conmentario si se quiere seguir la ejecución
//        System.out.format("Primera mitad de datos: %s\n",s);
	convertir(s,n/2,datos,0,n/2);
	ordenar(datos,0,n/2);
//Quitar el conmentario si se quiere seguir la ejecución
//	escribir(datos,n/2);
 	s=inStream.readLine();
//Quitar el conmentario si se quiere seguir la ejecución
//        System.out.format("Segunda mitad de datos ordenados: %s\n",s);
	convertir(s,n-n/2,datos,n/2,n);
	mezclar(datos,n);
//Quitar el conmentario si se quiere seguir la ejecución
//        escribir(datos,n);
        tf= System.currentTimeMillis()-ti;
        System.out.format("Tiempo paralelo: %d microsegundos\n",tf);
//        escribir(datos,n);
        System.out.format("Diferencia: %d\n",comparar(datos,copiadatos,n));
      }
      catch(IOException e)
      {
         System.err.println("Error en inStream.readLine()");
         e.printStackTrace();
      }
   } // Fin del método.
 
} // Fin de la clase.


